This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 677496 - Review Request: nbc - Next Byte Codes (NBC) and Not Exactly C (NXC)
Review Request: nbc - Next Byte Codes (NBC) and Not Exactly C (NXC)
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Martin Gieseking
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-02-14 20:28 EST by Rich Mattes
Modified: 2011-08-02 22:35 EDT (History)
3 users (show)

See Also:
Fixed In Version: nbc-1.2.1.r3-3.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-02 22:33:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
martin.gieseking: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Rich Mattes 2011-02-14 20:28:28 EST
Spec URL: http://rmattes.fedorapeople.org/RPMS/nbc/nbc.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/nbc/nbc-1.2.1.r3-2.fc14.src.rpm
Description: Next Byte Codes (NBC) is a simple language with an assembly language syntax that can be used to program LEGO's NXT programmable brick
(from the new LEGO Mindstorms NXT set).

Not Exactly C (NXC) is a high level language, similar to C, built on
top of the NBC compiler. It can also be used to program the NXT brick.
NXC is basically NQC (Not Quite C) for the NXT.

rpmlint:
$ rpmlint nbc.spec ../RPMS/x86_64/nbc*
2 packages and 1 specfiles checked; 0 errors, 0 warnings.

scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2840574
Comment 1 Martin Gieseking 2011-02-27 17:15:22 EST
Hi Rich,

here are some initial comments:

- I suggest to choose a more descriptive Summary, e.g. something like
  "Simple language to program LEGO's NXT programmable brick"

- Don't mix spaces and tabs for indentation. Just use one of them.

- please preserve the timestamps of all %doc files and the manpage. You can   
  accomplish this by adding the following to the %prep section:
    cd doc
    for f in Readme Changelog; do
      dos2unix -n $f $f.tmp && \
      touch -r $f $f.tmp && \
      mv $f.tmp $f
    done

  Drop the dos2unix lines from %build.
  Also, remove the call of gzip from the Makefile as rpmbuild compresses the 
  manpage automatically, and add switch -p to "install".

- Add %{_smp_mflags} to "make" in order to enable parallel builds.
Comment 2 Rich Mattes 2011-03-01 21:40:16 EST
(In reply to comment #1)
Thanks for the comments!
> - I suggest to choose a more descriptive Summary, e.g. something like
>   "Simple language to program LEGO's NXT programmable brick"
> 

I agree, I've done this.

> - Don't mix spaces and tabs for indentation. Just use one of them.
> 

I don't think I have?  rpmlint usually complains about this, and I can't find any tabs in the specfile

> - please preserve the timestamps of all %doc files and the manpage. You can   
>   accomplish this by adding the following to the %prep section:
>     cd doc
>     for f in Readme Changelog; do
>       dos2unix -n $f $f.tmp && \
>       touch -r $f $f.tmp && \
>       mv $f.tmp $f
>     done
> 
Neat trick, done.

>   Drop the dos2unix lines from %build.
>   Also, remove the call of gzip from the Makefile as rpmbuild compresses the 
>   manpage automatically, and add switch -p to "install".
> 

Done.

> - Add %{_smp_mflags} to "make" in order to enable parallel builds.

Done.

New spec & srpm:

Spec URL: http://rmattes.fedorapeople.org/RPMS/nbc/nbc.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/nbc/nbc-1.2.1.r3-3.fc14.src.rpm

$ rpmlint nbc.spec ../RPMS/x86_64/nbc-*
2 packages and 1 specfiles checked; 0 errors, 0 warnings.
Comment 3 Martin Gieseking 2011-07-18 13:53:11 EDT
Sorry for the delay. Here's the formal review. The package looks good and is ready now. Since the tarball lacks the license text as a separate file, you should ask upstream to add it in the next release (if the project is still alive).


$ rpmlint *.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license.
    - MPLv1.1

[+] MUST: The License field in the package spec file must match the actual license.
[.] MUST: The file containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source.
    $ md5sum nbc-1.2.1.r3.src.tgz*
    a640a5d74407ed976d6a1c565276bc6a  nbc-1.2.1.r3.src.tgz
    a640a5d74407ed976d6a1c565276bc6a  nbc-1.2.1.r3.src.tgz.1

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, ...
[+] MUST: All build dependencies must be listed in BuildRequires.
[.] MUST: When compiling C, C++, or Fortran files, %{optflags} must be applied.
[.] MUST: The spec file MUST handle locales properly.
[.] MUST: If a package installs files below %{_datadir}/icons, the icon cache must be updated.
[.] MUST: Packages storing shared library files (not just symlinks) must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, ...
[+] MUST: A package must own all directories that it creates. 
[+] MUST: A Fedora package must not list a file more than once in %files.
[+] MUST: Permissions on files must be set properly.
[.] MUST: Packages must not provide RPM dependency information when that information is not global in nature, or are otherwise handled.
[.] MUST: When filtering automatically generated RPM dependency information, the filtering system implemented by Fedora must be used.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage.
[+] MUST: Files in %doc must not affect the runtime of the application.
[.] MUST: Header files must be in a -devel package.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: .so with a suffix must go in a -devel package.
[.] MUST: devel packages must require the base package using a fully versioned dependency.
[+] MUST: Packages must NOT contain any .la libtool archives.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

EPEL <= 5 only:
[+] MUST: The spec file must contain a valid BuildRoot field.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot}.
[.] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'

[X] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[+] SHOULD: Timestamps of files should be preserved.
[+] SHOULD: Patch files should be prefixed with %{name}-
[+] SHOULD: All patches should be commented in the spec file
[+] SHOULD: The reviewer should test that the package builds in mock.
[.] SHOULD: If scriptlets are used, those scriptlets must be sane.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: pkgconfig(.pc) files should be placed in a -devel pkg.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[+] SHOULD: Your package should contain man pages for binaries/scripts.

----------------
Package APPROVED
----------------
Comment 4 Rich Mattes 2011-07-19 23:23:49 EDT
No problem, thanks for the review!
Comment 5 Rich Mattes 2011-07-19 23:25:00 EDT
New Package SCM Request
=======================
Package Name: nbc
Short Description: Simple language and compiler to program the LEGO NXT brick
Owners: rmattes
Branches: f14 f15
InitialCC:
Comment 6 Jon Ciesla 2011-07-20 06:03:25 EDT
Git done (by process-git-requests).
Comment 7 Fedora Update System 2011-07-21 16:07:05 EDT
nbc-1.2.1.r3-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/nbc-1.2.1.r3-3.fc14
Comment 8 Fedora Update System 2011-07-21 16:07:13 EDT
nbc-1.2.1.r3-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/nbc-1.2.1.r3-3.fc15
Comment 9 Fedora Update System 2011-07-22 21:59:03 EDT
nbc-1.2.1.r3-3.fc15 has been pushed to the Fedora 15 testing repository.
Comment 10 Fedora Update System 2011-08-02 22:33:53 EDT
nbc-1.2.1.r3-3.fc15 has been pushed to the Fedora 15 stable repository.
Comment 11 Fedora Update System 2011-08-02 22:35:29 EDT
nbc-1.2.1.r3-3.fc14 has been pushed to the Fedora 14 stable repository.

Note You need to log in before you can comment on or make changes to this bug.